//---------------------------------------------------------------------------

#ifndef MainFrmH
#define MainFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "TntForms.hpp"
#include "TntMenus.hpp"
#include <Menus.hpp>
#include "TntComCtrls.hpp"
#include "TntExtCtrls.hpp"
#include "TntStdCtrls.hpp"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ActnList.hpp>
//---------------------------------------------------------------------------

#define	sss	1

class TMooreaMainForm : public TTntForm
{
__published:	// IDE Ǘ̃R|[lg
	TTntMainMenu *TntMainMenu1;
	TTntMenuItem *File1;
	TTntMenuItem *miExit;
	TTntPanel *pnlTop;
	TTntComboBox *edPattern;
	TTntLabel *TntLabel1;
	TTntPanel *pnlSqu;
	TTntLabel *lbStatus;
	TTntLabel *TntLabel2;
	TTntComboBox *edDir;
	TTntButton *btnOption;
	TTntLabel *TntLabel3;
	TTntComboBox *edMask;
	TTntMenuItem *Tools1;
	TTntMenuItem *miOptions;
	TTntMenuItem *N1;
	TTntMenuItem *miOpenEditor;
	TTntLabel *lbTime;
	TTntMenuItem *Edit1;
	TTntMenuItem *miToUpper;
	TTntMenuItem *miToLower;
	TActionList *ActionList1;
	TAction *actToResult;
	TTntCheckBox *cbCaseSense;
	TTimer *tmPeriodic;
	TTntCheckBox *cbUseCache;
	TTntMenuItem *Help1;
	TTntMenuItem *miAbout;
	TTntMenuItem *miCopyResult;
	TTntMenuItem *miLoadCache;
	TTntMenuItem *miSaveCache;
	TTntMenuItem *N2;
	TTntMenuItem *Window1;
	TTntMenuItem *miNewTab;
	TTntMenuItem *miCloseTab;
	TActionList *ActionList2;
	TAction *actTab1;
	TAction *actTab2;
	TAction *actTab3;
	TAction *actTab4;
	TAction *actTab5;
	TAction *actTab6;
	TAction *actTab7;
	TAction *actTab8;
	TAction *actTab9;
	TTntLabel *lbWarning;
	TTntCheckBox *cbWord;
	TTntPopupMenu *pmOption;
	TTntMenuItem *miOnlyFilename;
	TTntMenuItem *miCheckTimestamp;
	TTntCheckBox *cbRegular;
	TTntMenuItem *miSearch;
	TTntMenuItem *miSearchSet;
	TTntMenuItem *miSortByFilename;
	TTimer *tmUpdate;
	TTntLabel *lbFileInfo;
	TTntMenuItem *miSearchClipboard;
	TTntCheckBox *cbHead;
	TTntMenuItem *View1;
	TTntMenuItem *miAlwaysOnTop;
	TTntMenuItem *miClear;
	TTntMenuItem *miSubDirectories;
	TTntMenuItem *miOpenTool;
	void __fastcall miExitClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall edPatternChange(TObject *Sender);
	void __fastcall TntFormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall edPatternKeyDown(TObject *Sender, WORD &Key,
		  TShiftState Shift);
	void __fastcall miOptionsClick(TObject *Sender);
	void __fastcall miOpenEditorClick(TObject *Sender);
	void __fastcall cmOpenEditorClick(TObject *Sender);
	void __fastcall miToUpperClick(TObject *Sender);
	void __fastcall miToLowerClick(TObject *Sender);
	void __fastcall actToResultExecute(TObject *Sender);
	void __fastcall lvResultDblClick(TObject *Sender);
	void __fastcall tmPeriodicTimer(TObject *Sender);
	void __fastcall cbCaseSenseClick(TObject *Sender);
	void __fastcall miAboutClick(TObject *Sender);
	void __fastcall miCopyResultClick(TObject *Sender);
	void __fastcall miLoadCacheClick(TObject *Sender);
	void __fastcall miSaveCacheClick(TObject *Sender);
	void __fastcall miNewTabClick(TObject *Sender);
	void __fastcall miCloseTabClick(TObject *Sender);
	void __fastcall actTabExecute(TObject *Sender);
	void __fastcall cbWordClick(TObject *Sender);
	void __fastcall btnOptionClick(TObject *Sender);
	void __fastcall miOnlyFilenameClick(TObject *Sender);
	void __fastcall miCheckTimestampClick(TObject *Sender);
	void __fastcall miSearchSetClick(TObject *Sender);
	void __fastcall miSortByFilenameClick(TObject *Sender);
	void __fastcall edDirChange(TObject *Sender);
	void __fastcall edMaskChange(TObject *Sender);
	void __fastcall tmUpdateTimer(TObject *Sender);
	void __fastcall miSearchClipboardClick(TObject *Sender);
	void __fastcall miSearchClick(TObject *Sender);
	void __fastcall cbHeadClick(TObject *Sender);
	void __fastcall miAlwaysOnTopClick(TObject *Sender);
	void __fastcall View1Click(TObject *Sender);
	void __fastcall miClearClick(TObject *Sender);
	void __fastcall miSubDirectoriesClick(TObject *Sender);
	void __fastcall miOpenToolClick(TObject *Sender);
private:	// [U[錾
	class TUIMain *UIMain;
	class TSquFrame *squfrm;

	void Initialize();
	void Cleanup();
	void LoadOptions();
	void SaveOptions();

	// Edit //
	void ClearEdit();

	// View //
	bool AlwaysOnTop;		// ɎO\
	void SetAlwaysOnTop(bool enabled);
	
	// message //
	int MsgPastTime;
	int MsgCount;

	bool UIChanging;

	// Result List //
	void ResultSelDown();
	void ResultSelUp();
	void NextSelFile();
	void PrevSelFile();
	void CopyResult();
	// Misc VCL //
	void __fastcall IdleHandler(TObject *sender, bool &done);
	void IdleProc(bool &done);
	// Key command //
	void KeyEnter();
	// Event //
	void EditChangeNotify();
	void DirChangeNotify();
	void MaskChangeNotify();
	// Command //
	void OpenEditor();
	void SearchClipboard();
	void SearchSetConfig();
	void DoSetting();
public:		// [U[錾
	__fastcall TMooreaMainForm(TComponent* Owner);
	__fastcall ~TMooreaMainForm();

	class TSquIF *squi();
//	class TSearchProcI *srchProc();
	
	// message
	void ClearMsg();
	//void SetMsg(int msgno, int pasttime=-1, int count=-1);
	void SetMsg(class TSquIF *sender, const tchar *msg, int pasttime=-1, int count=-1);
	void SetWarning(class TSquIF *sender, const tchar *msg);
	void SetFileInfo(class TSquIF *sender, const tchar *str);
protected:
	void updateMessageR();

public:
	void StartSearch();
	void SaveHistories();
	void NotifyTabChanged();
	void SetSearchParams(const struct TSearchParams &p);
protected:
	bool CacheLoaded;
};
//---------------------------------------------------------------------------
extern PACKAGE TMooreaMainForm *MooreaMainForm;
//---------------------------------------------------------------------------
#endif

