//---------------------------------------------------------------------------

#ifndef SearchSetDataH
#define SearchSetDataH
//---------------------------------------------------------------------------

struct TSearchSetItem {
	tnstr name;
	tnstr dir;
	tnstr mask;
	tnstr shortcut;
};

class TSearchSetData {
protected:
	typedef vector<TSearchSetItem> setvec_t;
	setvec_t Data;
public:
	TSearchSetData();
	virtual ~TSearchSetData();
//	TStringList *GetStrings()
//		{ return Jumps; }
	void SetString(int index, const tchar *str);
//	const tchar *GetString(int i)
//		{ return Data[i]; }
	int GetCount() const
		{ return Data.size(); }
	void Clear();

	tnstr GetFileName(int index);
	int FindShortcut(const tchar *shortcut, int start=0);
	void SetShortcut(int index, const tchar *shortcut);
	tnstr GetShortcut(int index);
};

void ParseJumpName(const tchar *text, tnstr &name, tnstr &shortcut);
tnstr BuildJumpName(const tchar *name, const tchar *shortcut);

#endif
