//---------------------------------------------------------------------------

#ifndef UIMainH
#define UIMainH
//---------------------------------------------------------------------------

#include "SquUIMain.h"

class TMooreaMainForm;

class TUIMain : public TSquUIMain {
typedef TSquUIMain super;
private:
	TMooreaMainForm *Main;
	static TUIMain *Instance;
private:
	TUIMain(TMooreaMainForm *main);
public:
	virtual ~TUIMain();
public:
	static TUIMain *CreateInstance(TMooreaMainForm *main);
	static TUIMain *GetInstance()
		{ return Instance; }

	// overrides //
	virtual void SetMsg(class TSquIF *sender, const tchar *str, int pasttime=-1, int count=-1);
	virtual void SetWarning(class TSquIF *sender, const tchar *str);
	virtual void SetFileInfo(class TSquIF *sender, const tchar *str);
	virtual void NotifyTabChanged();
};

#endif

