#ifndef	__JTYPE_H
#define	__JTYPE_H

// R[hΉ\ http://www.microsoft.com/globaldev/reference/dbcs/932.htm Q

#define	ucCODE_NAMI1  	0xFF5E	// `
#define	ucCODE_NAMI2	0x2026	// c
#define	ucCODE_NAMI3	0x2025	// d

#define	ucCODE_SPACE	0x3000	//@
#define	ucCODE_0		0xFF10	// O
#define	ucCODE_1		0xFF11	// P
#define	ucCODE_9		0xFF19	// X

#define	mbCODE_NAMI1  	0x8160	// `
#define	mbCODE_NAMI2	0x8163	// c
#define	mbCODE_NAMI3	0x8164	// d

#define	mbCODE_SPACE	0x8140	//@
#define	mbCODE_0		0x824F	// O
#define	mbCODE_1		0x8250	// P
#define	mbCODE_9		0x8258	// X

#ifdef _UNICODE

#define	CODE_NAMI1  	ucCODE_NAMI1
#define	CODE_NAMI2		ucCODE_NAMI2
#define	CODE_NAMI3		ucCODE_NAMI3

#define	CODE_GA			0x304C	// 
#define	CODE_NO			0x306E	// 
#define	CODE_NI			0x306B	// 
#define	CODE_WO			0x3092	// 

#define	CODE_COMMA1		0x3001	// A
#define	CODE_COMMA2		0x30FB	// E
#define	CODE_COMMA3		0x3002	// B
#define	CODE_BRACKET1	0x300C	// u
#define	CODE_BRACKET2	0x300D	// v
#define	CODE_JPROLONG	0x30FC	// [

#define	CODE_SEMICOLON	0xFF1B	// G
#define	CODE_COMMA		0xFF0C	// C
#define	CODE_APOSTROPHE	0x2019	// f
#define	CODE_QUOTATION	0x201D	// h

#define	CODE_SPACE		ucCODE_SPACE
#define	CODE_PERIOD		0xFF0E	// D

#define	CODE_LBR1		0xFF08	//i
#define	CODE_LBR2		0x3014	// k
#define	CODE_LBR3		0xFF3B	// m
#define	CODE_LBR4		0xFF5B	// o
#define	CODE_LBR5		0x3008	// q
#define	CODE_LBR6		0x300A	// s
#define	CODE_LBR7		0x300C	// u
#define	CODE_LBR8		0x300E	// w
#define	CODE_LBR9		0x3010	// y
#define	CODE_LBR10		0xFF1C	// 

#define	CODE_RBR1		0xFF09	// j
#define	CODE_RBR2		0x3015	// l
#define	CODE_RBR3		0xFF3D	// n
#define	CODE_RBR4		0xFF5D	// p
#define	CODE_RBR5		0x3009	// r
#define	CODE_RBR6		0x300B	// t
#define	CODE_RBR7		0x300D	// v
#define	CODE_RBR8		0x300F	// x
#define	CODE_RBR9		0x3011	// z
#define	CODE_RBR10		0xFF1E	// 

#define	CODE_L_A		0xFF21	// `
#define	CODE_L_Z		0xFF3A	// y

#define	CODE_S_A		0xFF41	// 
#define	CODE_S_Z		0xFF5A	// 

#define	CODE_0			ucCODE_0
#define	CODE_1			ucCODE_1
#define	CODE_9			ucCODE_9

#define	CODE_BLACK_SQUARE	0x25A0	// 
#define	CODE_BLACK_DIAMOND	0x25C6	// 
#define	CODE_BLACK_CIRCLE	0x25CF	// 

#else	// !_UNICODE

#define	CODE_NAMI1  	mbCODE_NAMI1
#define	CODE_NAMI2		mbCODE_NAMI2
#define	CODE_NAMI3		mbCODE_NAMI3

#define	CODE_GA			0x82aa	// 
#define	CODE_NO			0x82cc	// 
#define	CODE_NI			0x82c9	// 
#define	CODE_WO			0x82f0	// 

#define	CODE_COMMA1		0x8141	// A
#define	CODE_COMMA2		0x8145	// E
#define	CODE_COMMA3		0x8142	// B
#define	CODE_BRACKET1	0x8175	// u
#define	CODE_BRACKET2	0x8176	// v

#define	CODE_SEMICOLON	0x8147	// G
#define	CODE_COMMA		0x8143	// C
#define	CODE_APOSTROPHE	0x9188	// f

#define	CODE_SPACE		mbCODE_SPACE
#define	CODE_PERIOD		0x8144	// D

#define	CODE_LBR1		0x8169	//i
#define	CODE_LBR2		0x816b	// k
#define	CODE_LBR3		0x816d	// m
#define	CODE_LBR4		0x816f	// o
#define	CODE_LBR5		0x8171	// q
#define	CODE_LBR6		0x8173	// s
#define	CODE_LBR7		0x8175	// u
#define	CODE_LBR8		0x8177	// w
#define	CODE_LBR9		0x8179	// y
#define	CODE_LBR10		0x8183	// 

#define	CODE_RBR1		0x816a	// j
#define	CODE_RBR2		0x816c	// l
#define	CODE_RBR3		0x816e	// n
#define	CODE_RBR4		0x8170	// p
#define	CODE_RBR5		0x8172	// r
#define	CODE_RBR6		0x8174	// t
#define	CODE_RBR7		0x8176	// v
#define	CODE_RBR8		0x8178	// x
#define	CODE_RBR9		0x817a	// z
#define	CODE_RBR10		0x8184	// 

#define	CODE_L_A		0x8260	// `
#define	CODE_L_Z		0x8279	// y

#define	CODE_S_A		0x8281	// 
#define	CODE_S_Z		0x829a	// 

#define	CODE_0			mbCODE_0
#define	CODE_1			mbCODE_1
#define	CODE_9			mbCODE_9

#define	CODE_BLACK_DIAMOND	0x819F	// 
#define	CODE_BLACK_CIRCLE	0x819C	// 
#define	CODE_BLACK_SQUARE	0x81A1	// 

#endif	// !_UNICODE

#define	DLM_NONE	0
#define	DLM_EX		1
#define	DLM_COMMA	','

#include "tndefs.h"

#define	ucLD_CHAR(c,p)	c = *p++;
#define	ucST_CHAR(c,p)	*p++ = c;
#define	ucMOV_CHAR(p,q)	*p++ = *q++;
#define	ucIS_ENDCHAR(c)	(!(c))

#define	mbTYPE_CHAR		unsigned short
#define	mbLD_CHAR(c, p)	{c = (unsigned char)*(*(unsigned char**)&p)++; if(_ismbblead(c)) c = (unsigned short)(((unsigned short)c << 8) + (unsigned char)*(*(unsigned char**)&p)++);}
#define	mbST_CHAR(c, p)	{if ((unsigned short)c > 0x100) *(*(unsigned char**)&p)++ = (unsigned char)(c >> 8); *(*(unsigned char**)&p)++ = (unsigned char)c;}
#define	mbMOV_CHAR(p, q)	{ unsigned char c = *(*(unsigned char**)&q)++ = *(*(unsigned char**)&p)++; if ( _ismbblead( c ) ) *(*(unsigned char**)&q)++ = *(*(unsigned char**)&p)++; }
#define	mbIS_ENDCHAR(c)	(!((unsigned char)(c)))

#ifdef _UNICODE
#ifdef __UTF8
#define	TYPE_CHAR		unsigned long
#else
#define	TYPE_CHAR		wchar_t
#endif
#define	LD_CHAR(c,p)	ucLD_CHAR(c,p)
#define	ST_CHAR(c,p)	ucST_CHAR(c,p)
#define	MOV_CHAR(p,q)	ucMOV_CHAR(p,q)
#define	IS_ENDCHAR(c)	ucIS_ENDCHAR(c)
#else
#define	TYPE_CHAR		mbTYPE_CHAR
#define	LD_CHAR(c, p)	mbLD_CHAR(c,p)
#define	ST_CHAR(c, p)	mbST_CHAR(c,p)
#define	MOV_CHAR(p, q)	mbMOV_CHAR(p,q)
#define	IS_ENDCHAR(c)	mbIS_ENDCHAR(c)
#endif

bool islbr(unsigned short c);
bool isrbr(unsigned short c);
bool islbr2( unsigned short c );
bool isalphanum( int c );
bool isdelim(unsigned short c);
bool isdelim2(unsigned short c);
int jkstricmp( const tchar *str1, const tchar *str2 );
tchar *issuffix( const tchar *str );
#ifdef _UNICODE
#define	mbIsWordChar	IsWordChar
#else
bool mbIsWordChar( unsigned short c );
#endif

inline bool iskatakana( unsigned short c )
{
#ifdef _UNICODE
	return c >= _T('@') && c <= _T('');
#else
	return c >= 0x8340 && c <= 0x8396;
#endif
}
inline bool ishiragana( unsigned short c )
{
	return
#ifdef _UNICODE
		( c >= 0x3040 && c <= 0x309F )
#else
		( c >= 0x82a0 && c <= 0x82f1 )
#endif
	;
}
inline bool IsWordChar( tuchar c )
{
#ifdef _UNICODE
	return (c>='0'&&c<='9') || (c>='A'&&c<='Z') || (c>='a'&&c<='z') || c=='_';
#if 0
	WORD ct;
	GetStringTypeW(CT_CTYPE1,&c,1,&ct);
	return (ct & (C1_ALPHA|C1_DIGIT)) || c=='-' || c==CODE_JPROLONG || c=='\'' || c=='_';
#endif
#else
	return isalphanum( c ) || c == '-' || c == '\'' || c >= 0xc0;
#endif
}

bool IsWordChar(const tchar *s);

#ifdef _UNICODE
#define	LD_MCHAR(c, p, f)	LD_CHAR(c,p)
#define	ST_MCHAR(c, p, f)	ST_CHAR(c,p)
#define	MOV_MCHAR(p, q, f)	MOV_CHAR(p,q)
#define	_IsDBCSLeadByte(x)	(false)
#else
// VOoCgɂΉ
// f TRUÊƂ̓VOoCg
#define	LD_MCHAR(c, p, f)	{c = (unsigned char)*(*(unsigned char**)&p)++; if( !f && _ismbblead(c)) c = (unsigned short)(((unsigned short)c << 8) + (unsigned char)*(*(unsigned char**)&p)++);}
#define	ST_MCHAR(c, p, f)	{if ( !f && (unsigned short)c > 0x100) *(*(unsigned char**)&p)++ = (unsigned char)(c >> 8); *(*(unsigned char**)&p)++ = (unsigned char)c;}
#define	MOV_MCHAR(p, q, f)	{ unsigned char c = *(*(unsigned char**)&q)++ = *(*(unsigned char**)&p)++; if ( !f && _ismbblead( c ) ) *(*(unsigned char**)&q)++ = *(*(unsigned char**)&p)++; }
#define	_IsDBCSLeadByte(x)	IsDBCSLeadByte(x)
#endif

void elimchar( tchar *p );	// sR[h̏

void RemoveStr( tchar *str, const tchar *pattern1, const tchar *pattern2, int fKanaEnd );

#ifdef __tnstr_h
int jcut(tnstr &str, int len);
#endif

bool IsRegularChar(tchar c);

const tchar *NextDelim(const tchar *s);

#endif	// __JTYPE_H

