#ifndef __pfs_h
#define __pfs_h
//---------------------------------------------------------------------------

#ifdef	DEFINE_PFS
#define	DEF_PFS(name, str)	const tchar name[] = _t(str)
#else
#define	DEF_PFS(name, str)	extern const tchar name[];
#endif

DEF_PFS(PFS_MAIN, "Main");
//DEF_PFS(PFS_RESULT_HEIGHT, "ResultHeight");
DEF_PFS(PFS_BOTTOM_HEIGHT, "BottomHeight");
DEF_PFS(PFS_VIEWTOP, "ViewTop");

DEF_PFS(PFS_CASE, "Case");
DEF_PFS(PFS_HEAD, "Head");
DEF_PFS(PFS_WORD, "Word");
DEF_PFS(PFS_REGULAR, "Regular");

DEF_PFS(PFS_CONFIG, "Config");
DEF_PFS(PFS_EDITOR, "Editor");
DEF_PFS(PFS_TOOL, "Tool");

DEF_PFS(PFS_PATTERN_HISTORY, "PatternHistory");
DEF_PFS(PFS_DIR_HISTORY, "DirHistory");
DEF_PFS(PFS_MASK_HISTORY, "MaskHistory");

DEF_PFS(PFS_COMMON, "Common");
DEF_PFS(PFS_TABNAMES, "TabNames");
DEF_PFS(PFS_ACTIVETAB, "ActiveTab");

#endif

