//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "prgprofile.h"
#include "prgcommon.h"
#include "filestr.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

PrgProfile prof;

void InitProfile()
{
	tnstr iniName = ModuleFileName;
	iniName = ChangeFileExt(iniName, _t("ini"));
	prof.SetIniMode(iniName);
	prof.Open(NULL);	// dummy open to create RootKey
}

void WriteHistory( const tchar *section, tnstr_vec &ha)
{
	TRegKey &reg = *prof.SetSection( section );
	// delete section
	reg.EraseAllEntry();
	for (int i=0;i<ha.GetCount();i++){
		tchar entry[10];
		_itot(i,entry,10);
		reg.WriteString(entry, ha[i]);
	}
}

void ReadHistory( const tchar *section, tnstr_vec &ha)
{
	ha.clear();
	TRegKey &reg = *prof.SetSection( section );
	for (int i=0;;i++){
		tchar entry[10];
		_itot(i,entry,10);
		tnstr str;
		str = reg.ReadString( entry );
		if (str.IsEmpty())
			break;
		ha.push( str );
	}
}


