//---------------------------------------------------------------------------

#ifndef SquFrmH
#define SquFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "TntForms.hpp"
#include "TntComCtrls.hpp"
#include <ComCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------

class TSquIF;

typedef FlexObjectArray<TSquIF> square_vec;
#define	foreach_square(it)	TSquIF *it; for(int i=0;it=&Squares[i],i<Squares.get_num();i++)

class TSquFrame : public TTntFrame
{
__published:	// IDE Ǘ̃R|[lg
	TScrollBox *ScrollBox1;
	TTntPageControl *SquareTab;
	void __fastcall SquareTabChange(TObject *Sender);
	void __fastcall SquareTabDragOver(TObject *Sender, TObject *Source, int X,
          int Y, TDragState State, bool &Accept);
	void __fastcall SquareTabEndDrag(TObject *Sender, TObject *Target, int X,
          int Y);
	void __fastcall SquareTabMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// [U[錾
	square_vec Squares;
	class TSquIF *Active;
	class TSquUIMain *UIMain;
	// Tab control //
	int UniqFrameNumber;
	bool TabVisible;
protected:
public:		// [U[錾
	__fastcall TSquFrame(TComponent* Owner, TSquUIMain *main);
	class TSquIF *GetActive()
		{ return Active; }
	class TSqu *GetActiveS();
	class MPdic *GetActiveDic();
protected:
	bool SetActive(TTabSheet *active);
	void ChangeActive(TSquIF *obj);
	bool _CanClose(bool withmsg);
public:
	class TSquUIMain *GetUIMain(){ return UIMain; }
	//class TSquUIWord *GetUIWord(){ return UIWord; }
	void Setup();
	void Cleanup();
	// Profile //
	void LoadProfile();
	void SaveProfile();
	// GUI //
	void ResetFont();
	void ResetColor();
	void EvActivate(bool active);
	// Tab operations //
	bool NewTab();
	void CloseTab();
	void PrevTab();
	void NextTab();
	void NotifyTabChanged();
	void SetTabName(const tchar *name);
	int FindTab(const tchar *name);
	int GetTabCount();
	void SelectTab(int no);
	void MoveActiveTab(int new_index);
	bool GetTabVisible() const
		{ return TabVisible; }
	void SetTabVisible(bool visible);
	void SaveTabs();
	void RestoreTabs();
	void RestoreActiveTab();
protected:
	void ChangeTabVisible();
public:
	// Message //
	void SetMsg(TSquIF *sender, const tchar *msg, int pasttime, int count);
	//void SetMsg(class TSqu *sender, const tchar *msg, int pasttime, int count);
	// delegators //
	bool IsSearchingAll();
	void StopSearchAll();
	// Misc //
	bool IdleProc();
};
//---------------------------------------------------------------------------
extern PACKAGE TSquFrame *SquFrame;
//---------------------------------------------------------------------------
#endif

