//---------------------------------------------------------------------------

#ifndef vclcomH
#define vclcomH
//---------------------------------------------------------------------------

//#include "tnlib.h"
#include "defs.h"
#include "TntComCtrls.hpp"
#include "TntExtCtrls.hpp"
#include "TntComCtrls.hpp"
#include "TntForms.hpp"
//#include "hgrparr.h"

// String Operations
// AnsiStringWideString̈Ⴂz邽߂̃}N
// c_tstr()͊SȌ݊Ȃ̂Ōgp֎~(tnstrւ̑ȂOK)
#if defined(UNICODE)
#define	_TString		WideString
#define	_c_tstr			c_bstr
#define	_TStringList	TTntStringList
#define	__WITHBOM__		, true
#define	_toString(s)	((tchar*)(const tchar*)(s))	// WideString = const tchar *ƂŃG[ƂȂ邽
#define	_toString2(s)	_TString(s)					// toStringł͂܂삵Ȃꍇ
#define	_totchar(s)		((s).c_bstr() ? (s).c_bstr() : _T(""))	// c_str()݊̂߁Bc_str()ƈقȂANULLԂꍇ邽
#define	TtoWString(s)	(s).c_str()					// WideString = TNChar̂
#else	// !defined(UNICODE)
#define	_TString		AnsiString
#define	_c_tstr			c_str
#define	_TStringList	TStringList
#define	__WITHBOM__
#define	_toString(s)	(s)
#define	_toString2		_toString
#define	_totchar(s)		(s).c_str()
#define	TtoWString(s)	(s)
#endif

// shift flag for shortcut key
#define SK_SHIFT            0x2000
#define SK_CTRL				0x4000
#define	SK_ALT				0x8000
#define	SK_ALTMASK			0x20000000	// Menus.pasɂAltMaskɑΉ邽(shortcut keyŎgp)

#define	VCL_CENTER()	MoveCenter(this, (TWinControl*)Owner)
#define	VCL_SIZEABLE()	do {BorderStyle = bsSizeable;} while(0)	//TODO: VCL Bug

void LoadForm( class TRegKey *key, class TForm *form, TWinControl *parent);
void LoadForm( class TRegKey *key, class TForm *form, HWND hwnd );
void SaveForm( class TRegKey *key, class TForm *form, TWinControl *parent);
void SaveForm( class TRegKey *key, class TForm *form, HWND hwnd );
void DeleteForm( class TRegKey *key );
void MoveCenter(TForm *form, TWinControl *parent=NULL);
void LoadListView(TRegKey *key, TTntListView *lv);
void SaveListView(TRegKey *key, TTntListView *lv);

int ShiftStatusToMouseKey(TShiftState shift);
int ShiftStatusToKeyState(TShiftState shift);

#include "TntStdCtrls.hpp"

#include <vector>
using namespace std;

class TRadioGrouping {
typedef vector<TRadioButton*> rbtn_vec;
private:
	rbtn_vec Buttons;
public:
	TRadioGrouping();
	virtual ~TRadioGrouping();
	void Add(TRadioButton *rb)
		{ Buttons.push_back(rb); }
	int GetItemIndex();
	void SetItemIndex(int index);
};

// Data Transfer //
class HistoryArray;
void GetData(TTntComboBox *cb, HistoryArray *ha);
void SetData(TTntComboBox *cb, HistoryArray *ha);

// start of data transfer helper //
enum TransferDir {
	tdSet,
	tdGet,
};
void DT(TransferDir dir, TTntRadioGroup *rg, int &val);
void DT(TransferDir dir, TTntComboBox *cb, int &val);
void DT(TransferDir dir, TTntComboBox *cb, HistoryArray *array);
void DT(TransferDir dir, TTntComboBox *cb, class HistoryGroupArray *array);
void DT(TransferDir dir, TTntCheckBox *cb, bool &checked);
void DT(TransferDir dir, TTntCheckBox *cb, int &val, int flag);
void DT(TransferDir dir, TTntRadioButton *rb, bool &checked);
inline void DT(TransferDir dir, TTntEdit *ed, tnstr *text)
{
	if (dir==tdSet){
		ed->Text = *text;
	} else {
		*text = ed->Text;
	}
}
inline void DT(TransferDir dir, TTntEdit *ed, tnstr &text)
{
	if (dir==tdSet){
		ed->Text = text;
	} else {
		text = ed->Text;
	}
}
#if 0
inline void DT(TransferDir dir, TEdit *ed, tnstr *text)
{
	if (dir==tdSet){
		ed->Text = tnstrAx(*text);
	} else {
		*text = _tnstrWx(ed->Text);
	}
}
inline void DT(TransferDir dir, TEdit *ed, tnstr &text)
{
	if (dir==tdSet){
		ed->Text = tnstrAx(text);
	} else {
		text = _tnstrWx(ed->Text);
	}
}
#endif
void DT(TransferDir dir, TTntEdit *ed, int &val);
void DT(TransferDir dir, TTntLabel *label, tnstr &text);
void DT(TransferDir dir, TTntUpDown *ud, int &val);
void DT(TransferDir dir, TTntTrackBar *ud, int &val);

void DT(TransferDir dir, TRadioGrouping &rg, int &index);

// Items setters //
void SetItems(TTntComboBox *cb, const tnstr_vec &array);
void SetItems(TTntListBox *lb, const tnstr_vec &array);
void SetItems(TTntStrings *strs, const tnstr_vec &array);
void SetItems(TTntComboBox *cb, int idlist[]);
//void SetItems(TTntComboBox *cb, int start_id, int end_id);	// depricated.
void SetItems(TTntComboBox *cb, const tchar *strings, const tchar *delm=NULL);

void GetItems(TTntListBox *lb, tnstr_vec &array);
void GetItems(TTntStrings *strs, tnstr_vec &array);

inline void DT(TransferDir dir, TTntListBox *lb, tnstr_vec &array)
{
	if (dir==tdSet){
		SetItems(lb, array);
	} else {
		GetItems(lb, array);
	}
}

// Font operation //
int ToInteger(TFontStyles fs);
void ToFontStyles(int val, TFontStyles &fs);
TFontStyles ToFontStyles(int val);
int VclColorToSysColor(TColor color);
TColor SysColorToVclColor(COLORREF color, TColor defcolor);

void SetFont(TFont *font, LOGFONT &lf, bool useNormalSize=false);	// LOGFONT -> TFont
int SetFont(TFont *font, LOGFONT &lf, bool userNormalSize, HDC hdc, bool includeAscent);
TFontStyles ExtractFontStyle(const LOGFONT &lf);	// LOGFONT -> FontStyle
void GetFont(TFont *font, LOGFONT &lf);	// TFont -> LOGFONT
void GetFontStyle(const TFontStyles &style, LOGFONT &lf);	// FontStyle -> LOGFONT

void SetFont(TFont *font, const class TFontAttr &fa, bool useNormalSize=false);	// TFontAttr -> TFont
int SetFont(TFont *font, const TFontAttr &fa, bool userNormalSize, HDC hdc, bool includeAscent);
TFontStyles ExtractFontStyle(const TFontAttr &fa);	// TFontAttr -> FontStyle
void GetFont(TFont *font, TFontAttr &fa);	// TFont -> TFontAttr
void GetFontStyle(const TFontStyles &style, TFontAttr &fa);	// FontStyle -> TFontAttr

// Edit Control //
// SetSelection for TTntEdit bug. SelStart of TTntEdit count the caret location by ANSI!!
// GetSelection() as well.
inline void vclSetSelStartLen(TTntCustomEdit *edit, int sel_start, int sel_length)
{
	::SendMessage(edit->Handle, EM_SETSEL, sel_start, sel_start+sel_length);
}
inline void vclSetSelStartLen(TTntCustomMemo *edit, int sel_start, int sel_length)
{
	::SendMessage(edit->Handle, EM_SETSEL, sel_start, sel_start+sel_length);
}
inline void vclSetSelStartEnd(TTntCustomEdit *edit, int sel_start, int sel_end)
{
	::SendMessage(edit->Handle, EM_SETSEL, sel_start, sel_end);
}
inline void vclGetSelStartEnd(TTntCustomEdit *edit, int &start, int &end)
{
	::SendMessage(edit->Handle, EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
}
inline void vclGetSelStartEnd(TTntRichEdit *edit, int &start, int &end)
{
	::SendMessage(edit->Handle, EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
}
inline void vclGetSelStartLen(TTntCustomEdit *edit, int &start, int &length)
{
	int end;
	::SendMessage(edit->Handle, EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
	length = end - start;
}
inline int vclGetSelStart(TTntCustomEdit *edit)
{
	int start, end;
	::SendMessage(edit->Handle, EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
	return start;
}

// Memo //
void vclSetLines(TTntMemo *edit, const tchar *text);

// UpDown //
bool vclCanCloseUpDown(TTntUpDown *ud);
void vclUpDownError(TTntUpDown *ud);	// You must implement somewhere in your application.
#define	VCL_CHKUD(ud)	if (!vclCanCloseUpDown(ud)) { CanClose = false; vclUpDownError(ud); ud->Associate->SetFocus(); return; }
#define	VCL_CHKUDR(ud)	if (!vclCanCloseUpDown(ud)) { vclUpDownError(ud); ud->Associate->SetFocus(); return false; }

// Key Combinations //
extern TShiftState sscNone, sscCtrl, sscShift, sscAlt;

// Cursor //
void SetCursor(TControl *ctrl, const tchar *name);

// Dialog //
void ShowDialog(TTntForm *dlg, TWinControl *parent);
void CloseDialog(TTntForm *dlg, TWinControl *parent);
void ChangeCloseDialog(TTntForm *dlg, TWinControl *parent);

// Countermeasure //
void VCLRadioGroupFocusHandler(TTntForm *form, TObject *sender, bool enter);
void VCLRadioGroupSetFocus(TTntForm *form, TTntRadioGroup *rg);

void vclSetVclBugHelper(HWND hwnd, int msg);
void vclVclBugHandler(WPARAM wparam, LPARAM lparam);

void vclSetFocus(HWND handle);

// Application //
void vclProcessMessage();
void vclHandleMessage();

// Menu //
inline void ToggleMenuCheck(TTntMenuItem *menu)
	{ menu->Checked = !menu->Checked; }

void ListItemExchange(TTntListView *lv, int i1, int i2);

#endif

