//---------------------------------------------------------------------------

#ifndef FindFileTaskH
#define FindFileTaskH
//---------------------------------------------------------------------------

#include "SrchDef.h"

#define	DIR_C			'\\'

#include "ThreadTask.h"

#include "FindStrTask.h"

class TFindFileTask : public TThreadTask {
typedef TThreadTask super;
protected:
	tnstr Pattern;
	tnstr Dir;
	tnstr_vec Masks;
	int Option;
	FNFoundCallback FoundCallback;
	void *UserData;
	TFindStrTask *FindStrTask;
public:
	void Setup(const tchar *pattern, const tchar *dir, const tchar *masks, int option, FNFoundCallback foundcallback, void *userdata);
	virtual void Stop();
	const tchar *GetPattern() const
		{ return Pattern; }
protected:
	// Thread
	virtual void Execute();
	bool FindDirs(const tchar *dir);
};

#endif

