//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "SearchSetData.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
TSearchSetData::TSearchSetData()
{
}
TSearchSetData::~TSearchSetData()
{
}
#if 0
void TSearchSetData::SetString(int index, const tchar *str)
{
	SetData[index] = str;
}
#endif
void TSearchSetData::Clear()
{
	Data.clear();
}
tnstr TSearchSetData::GetFileName(int index)
{
	return Data[index].name;
}
int TSearchSetData::FindShortcut(const tchar *shortcut, int start)
{
	int len_shortcut = _tcslen(shortcut);
	for (int i=start;i<Data.size();i++){
		const tnstr &value = Data[i].shortcut;
		if (Data[i].shortcut.length()>=len_shortcut && value[1]=='^' && value[2]!='^'){
			if (!_tcsncmp(value.c_str(), shortcut, len_shortcut)
				&& (value.Length()==len_shortcut || value[len_shortcut+1]==' ') ){
				return i;
			}
		}
	}
	return -1;
}
#if 0
// set shortcut without duplicate check
void TSearchSetData::SetShortcut(int index, const tchar *shortcut)
{
	tnstr name;
	tnstr dummy;
	ParseJumpName(Values[Jumps->Names[index]].c_str(), name, dummy);
	Data.Values[Jumps->Names[index]] = BuildJumpName(name.c_str(), shortcut);
}
AnsiString TSearchSetData::GetShortcut(int index)
{
	AnsiString name;
	AnsiString shortcut;
	ParseJumpName(Jumps->Values[Jumps->Names[index]].c_str(), name, shortcut);
	return shortcut;
}
#endif

#if 0
// format:
//	[^\d ][filename]
//	or
//	[filename]
//	If filename starts with ^ then character ^ will be added.
void ParseJumpName(const tchar *text, tnstr &name, tnstr &shortcut)
{
	if (text[0]=='^'){
		if (text[1]=='^'){
			shortcut = "";
			text++;
		} else
		if (text[1]!='\0' && (text[2]==' ' || text[2]=='\0')){
			shortcut = "^" + AnsiString(text[1]);
			text += 2;
			if (text[0]) text++;
		}
	}
	name = text;
}
tnstr BuildJumpName(const tchar *name, const tchar *shortcut)
{
	if (strncmp(shortcut, "^", 1)==0){
		return AnsiString("^") + shortcut[1] + " " + name;
	} else {
		if (name[0]=='^'){
			return AnsiString("^") + name;
		}
		return name;
	}
}
#endif
