//---------------------------------------------------------------------------

#ifndef SearchSetDlgH
#define SearchSetDlgH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "TntForms.hpp"
#include "TntMenus.hpp"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include "TntStdCtrls.hpp"
#include "TntComCtrls.hpp"
//---------------------------------------------------------------------------
class TSearchSetDialog : public TTntForm
{
__published:	// IDE Ǘ̃R|[lg
	TBitBtn *RemoveBtn;
	TButton *EditPathBtn;
	TTntListView *JumpList;
	TTntPopupMenu *pmContext;
	TTntMenuItem *miUp;
	TTntMenuItem *miDown;
	TTntButton *btnOk;
	TTntButton *btnCancel;
	TTntButton *btnUp;
	TTntButton *btnDown;
	void __fastcall TntFormShow(TObject *Sender);
	void __fastcall EditPathBtnClick(TObject *Sender);
	void __fastcall RemoveBtnClick(TObject *Sender);
	void __fastcall btnUpClick(TObject *Sender);
	void __fastcall btnDownClick(TObject *Sender);
	void __fastcall miUpClick(TObject *Sender);
	void __fastcall miDownClick(TObject *Sender);
private:	// [U[錾
	TTntStringList *Shortcuts;
public:		// [U[錾
	__fastcall TSearchSetDialog(TComponent* Owner);
	_fastcall virtual ~TSearchSetDialog();
	void AddItems(TTntStrings *items);
	void AddItem(const tchar *name, const tchar *filename);
	bool CheckShortcutDup(int pri);
	void GetItems(TTntStrings *items);
	int GetSelIndex();
	void MoveUp();
	void MoveDown();
};
//---------------------------------------------------------------------------
extern PACKAGE TSearchSetDialog *SearchSetDialog;
//---------------------------------------------------------------------------
#endif
