//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "tnlib.h"

#include "SearchSetEditDlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TntStdCtrls"
#pragma resource "*.dfm"
TSearchSetEditDialog *SearchSetEditDialog;
//---------------------------------------------------------------------------
__fastcall TSearchSetEditDialog::TSearchSetEditDialog(TComponent* Owner)
	: TTntForm(Owner)
{
}
//---------------------------------------------------------------------------
void TSearchSetEditDialog::Setup(const tchar *name, const tchar *dir, const tchar *mask, const tchar *shortcut)
{
}

void TSearchSetEditDialog::SetShortcut(const tchar *str)
{
	if (_tcsncmp(str, _t("Alt+"), 5)==0){
		// Alt+
		switch (str[5]){
			case '0':
				cbShortcut->ItemIndex = 10;
				break;
			default:
				cbShortcut->ItemIndex = str[5]-'0';
				break;
		}
	}
}
tnstr TSearchSetEditDialog::GetShortcut()
{
	switch (cbShortcut->ItemIndex){
		case 0:
			return NULL;
		case 10:
			return _t("Alt+0");
		default:
			{
				tnstr ret(_t("Alt+"));
				ret += cbShortcut->ItemIndex;
				return ret;
			}
	}
}
