//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "vclcom.h"
#include "tnlib.h"

#include "SettingDlg.h"
#include "prgprofile.h"
#include "pfs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TntDialogs"
#pragma link "TntStdCtrls"
#pragma link "TntExtCtrls"
#pragma link "TntMenus"
#pragma resource "*.dfm"
TSettingDialog *SettingDialog;
//---------------------------------------------------------------------------
__fastcall TSettingDialog::TSettingDialog(TComponent* Owner)
	: TTntForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSettingDialog::TntFormShow(TObject *Sender)
{
	VCL_CENTER();
	edEditor->Text = prof.ReadString(PFS_CONFIG, PFS_EDITOR, edEditor->Text.c_bstr());
	edTool->Text = prof.ReadString(PFS_CONFIG, PFS_TOOL, edTool->Text.c_bstr());
}
//---------------------------------------------------------------------------
void __fastcall TSettingDialog::TntFormCloseQuery(TObject *Sender,
      bool &CanClose)
{
	if (ModalResult!=mrOk)
		return;
	prof.WriteString(PFS_CONFIG, PFS_EDITOR, edEditor->Text.c_bstr());
	prof.WriteString(PFS_CONFIG, PFS_TOOL, edTool->Text.c_bstr());
}
//---------------------------------------------------------------------------
void __fastcall TSettingDialog::btnBrEditorClick(TObject *Sender)
{
//	OpenDialogEditor->FileName = edEditor->Text;
	if (OpenDialogEditor->Execute())
		edEditor->Text = OpenDialogEditor->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TSettingDialog::btnPresetClick(TObject *Sender)
{
	POINT pt;
	GetCursorPos(&pt);
	SendMessage(btnPreset->Handle, WM_CONTEXTMENU, 0, MAKELPARAM(pt.x, pt.y));
}
//---------------------------------------------------------------------------
void __fastcall TSettingDialog::pmPresetClick(TObject *Sender)
{
	static const tchar *Preset[] = {
		_t("/j$l,$c $f"),
		_t("$f -X=$c -Y=$l")
	};
	int index = ((TTntMenuItem*)Sender)->Tag;
	edEditor->Text = edEditor->Text + _t(" ") + Preset[index];
}
//---------------------------------------------------------------------------
void __fastcall TSettingDialog::btnToolBrowseClick(TObject *Sender)
{
	if (OpenDialogTool->Execute())
		edTool->Text = OpenDialogTool->FileName;
}
//---------------------------------------------------------------------------

