//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "UIMain.h"
#include "MainFrm.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

TUIMain *TUIMain::Instance = NULL;

TUIMain::TUIMain(TMooreaMainForm *main)
{
	Main = main;
}
TUIMain::~TUIMain()
{
	Instance = NULL;
}
TUIMain *TUIMain::CreateInstance(TMooreaMainForm *main)
{
	if (Instance)
		return Instance;
	return Instance = new TUIMain(main);
}

void TUIMain::SetMsg(class TSquIF *sender, const tchar *str, int pasttime, int count)
{
	Main->SetMsg(sender, str, pasttime, count);
}
void TUIMain::SetWarning(class TSquIF *sender, const tchar *str)
{
	Main->SetWarning(sender, str);
}
void TUIMain::SetFileInfo(class TSquIF *sender, const tchar *str)
{
	Main->SetFileInfo(sender, str);
}
void TUIMain::NotifyTabChanged()
{
	Main->NotifyTabChanged();
}

