//---------------------------------------------------------------------------

#include "tnlib.h"
#pragma hdrstop

#include "ThreadTask.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)

bool TThreadTask::Start()
{
	DWORD ThreadId;
	hThread = CreateThread(NULL, 0, ThreadEntry, this, CREATE_SUSPENDED, &ThreadId);
	if (!hThread){
		// thread creation failed.
		return false;
	}
//	SetThreadPriority(hThread, THREAD_PRIORITY_BELOW_NORMAL	);
	ResumeThread(hThread);
	return true;
}
void TThreadTask::Stop()
{
	StopReq = true;
}

int TThreadTask::WaitFor()
{
	if (!hThread)
		return -1;	//
	WaitForSingleObject(hThread, INFINITE);
	DWORD code;
	GetExitCodeThread(hThread, &code);
	return code;
}

DWORD WINAPI TThreadTask::ThreadEntry(LPVOID param)
{
	((TThreadTask*)param)->_Execute();
	return 0;
}

void TThreadTask::_Execute()
{
	Execute();
	if (SelfDelete){
		delete this;
	}
}

