#ifndef	__DEFS_H
#define	__DEFS_H

#include "tndefs.h"

#ifndef _time_t
#define	_time_t	time_t		//TODO: 2038 year problem.
#endif

#ifndef __override
#define	__override	virtual
#endif

#ifdef	_Windows
#define	LPISFAR			// LP32rbgł
#endif

#ifdef __WIN32__
#define	L_FILENAME	MAX_PATH		// x[X{'.'{gq
#else
#define	L_FILENAME	MAX_PATH		// x[X{'.'{gq
#endif

#ifndef MAXPATH
#define	MAXPATH	_MAX_PATH
#endif
#ifndef MAX_PATH
#define	MAX_PATH	MAXPATH
#endif

#ifdef _UNICODE
#define	_mt(x)	__mustr(x)
#define	CF_TTEXT	CF_UNICODETEXT
#else
#define	_mt(x)	(x)
#define	CF_TTEXT	CF_TEXT
#endif

// C++Builder6 ΍
#if defined(__BORLANDC__) && (__BORLANDC__>=0x0560) && !defined(max)
#define	max(x,y)	( ( (x) > (y) ) ? (x) : (y) )
#endif

/*======================================*/
/*DOSpAWindows|[^reBmdefine*/
/*======================================*/
#if defined(DOS) || defined(UNIX) || defined(STDLIB)

#define	VOID			void
#define	FAR
#define	NEAR
#ifndef PASCAL
#define	PASCAL
#endif
#ifndef CDECL
#define	CDECL
#endif

typedef char TCHAR;

#if !defined(CYGWIN)
typedef unsigned short	WORD;
typedef	unsigned long	DWORD;
typedef long			LONG;
typedef unsigned int	UINT;
typedef	unsigned char	BYTE;
typedef	int				BOOL;
#define	FALSE			0
#define	TRUE			1
// ȉWindowsƔRp`u
typedef	const tchar *	LPCTSTR;
typedef	tchar *			LPTSTR;
typedef	tchar *			NPSTR;
typedef	void *			LPVOID;
typedef	DWORD*			LPDWORD;
typedef	long *			LPLONG;
typedef	WORD *			LPWORD;
typedef	int *			LPINT;
typedef	BYTE *			LPBYTE;
typedef	void *			LPVOID;
#endif	// !defined(CYGWIN)

#if !defined(PDIC32)
typedef struct tagSIZE {
	LONG cx;
	LONG cy;
} SIZE;
#endif


typedef	int				HFILE;
#define HFILE_ERROR ((HFILE)-1)

//	WCu far >> near u
#if defined(CYGWIN)
#define	lstrlen			strlen
#define	lstrcpy			strcpy
#define	lstrncpy		strncpy
#define	lstrcat			strcat
#define	lstrcmp			strcmp
#define	ljstrrchr		jstrrchr
#define	ljstrchr		jstrchr
#define	lmemcpy			memcpy
#define	lmemset			_fmemset
#endif

#ifdef UNIX
#define	lfstrcpy		strcpy
#define	lfstrlen		strlen
#define	lfstrcmp		strcmp
#else
#define	lfstrcpy		_fstrcpy
#define	lfstrlen		_fstrlen
#define	lfstrcmp		_fstrcmp
#endif

#define	_tcslen			strlen
#define	_tcscmp			strcmp
#define	_tcsncmp		strncmp
#define	_tcscpy			strcpy
#define	_tcsncpy		strncpy

#else

//	WCuu
#ifdef __WIN32__
#define	ljstrrchr		jstrrchr
#define	ljstrchr		jstrchr
#define	lstrncpy		strncpy
#define	lfstrcpy		_tcscpy
#define	lfstrlen		_tcslen
#define	lfstrcmp		_tcscmp
#define	lmemcpy			memcpy
#define	lmemset			memset
#else
#define	ljstrrchr		_fjstrrchr
#define	ljstrchr		_fjstrchr
#define	lstrncpy		_fstrncpy
#define	lfstrcpy		strcpy
#define	lfstrlen		strlen
#define	lfstrcmp		strcmp
#define	lmemcpy			_fmemcpy
#define	lmemset			_fmemset
#endif
#endif

#ifdef _UNICODE
//#pragma	message( "UNICODE iskanji is not supported!!" );
#define	_tiskanji(x)	(x >= 0x100)
#else
#define	_tiskanji		_ismbblead
#endif

// BC++Œ`ς݁AMSCŖ`
#if defined(_MSC_VER) || defined(UNIX)
#define	_fstrcmp		strcmp
#define	_fmemcpy		memcpy
#define	_fmemset		memset
#endif

// PDICpǉ //////////////////////////

//#define min(a,b)    (((a) < (b)) ? (a) : (b))

#if !defined(_UNICODE) && defined(_Windows)
typedef	const TCHAR *PCSTR;
#endif

#ifdef	_Windows
// near|C^[ΏۂƂAnsiNext()
inline TCHAR *GetNextPtr( const TCHAR *p )
{
#ifdef ANSI
	return NEXT_CHAR( p );
#else
	return CharNext( p );
#endif
}
#ifdef _UNICODE
#define	NEXT_P( p )	(*(tchar**)&p)++
#else
#define	NEXT_P( p ) p = CharNext( p )
#endif
#else
#define	NEXT_P( p )	if ( _ismbblead( *p ) ) p++; p++
inline tchar *GetNextPtr( const tchar *p )
{
	NEXT_P( p );
	return (tchar*)p;
}
#endif

#define	SETFLAGS( flags, flag, b )		if ( b ) flags |= (flag); else flags &= ~(flag);

// ߂l\0pointerԂ
inline TCHAR *strcpy2( TCHAR *dest, const TCHAR *str )
{
	int len = _tcslen(str);
	memcpy( dest, str, (len+1)*sizeof(tchar) );
	return dest + len;
}

#ifdef _MSC_VER
inline tchar *_mbstok( tchar *buf, const tchar *str )
{
	return (tchar*)_tmbstok( (tuchar *)buf, (const tuchar*)str );
}
#if 0
inline int _mbsnicmp( const tchar *str1, const tchar *str2, unsigned len )
{
	return _tmbsnicmp( (const tuchar *)str1, (const tuchar*)str2, len );
}
#endif
int _mbsnicmp( const char *str1, const char *str2, unsigned len );
#endif

//////// Compatibility for WinCE ////////
#ifdef WINCE
#define	TPM_LEFTBUTTON			0
#endif

#include "tnstr.h"
#define	tnstrW			_tnstrW
#define	tnstrA			_tnstrA
#define	tnstrWx			_tnstrWx
#define	tnstrAx			_tnstrAx

// for VCL application
#if defined(_UNICODE)
#define	TString			_tnstrW
#define	TStringA		_tnstrA
#define	TStringW		_tnstrW
#else	// !defined(_UNICODE)
#define	TString			_tnstrA
#endif

// for TNChar to comprise with WideString
#define	c_ws	c_str

#define	def_cstr(name, str)	\
	const tchar *name = _t(str)

class TMutex {
protected:
	CRITICAL_SECTION cs;
public:
	TMutex()
	{
		InitializeCriticalSection(&cs);
	}
	~TMutex()
	{
		DeleteCriticalSection(&cs);
	}
	void Lock()
	{
		EnterCriticalSection(&cs);
	}
	void Unlock()
	{
		LeaveCriticalSection(&cs);
	}
	bool IsLocked()
	{
		if (TryEnterCriticalSection(&cs)){
			LeaveCriticalSection(&cs);
			return true;
		}
		return false;
	}
};

class TAutoLock {
protected:
	TMutex &Mutex;
public:
	TAutoLock(TMutex &mutex)
		:Mutex(mutex)
	{
		Mutex.Lock();
	}
	~TAutoLock()
	{
		Mutex.Unlock();
	}
};

// very useful version of 'auto_ptr'
template<class X> class autoptr
{
//#ifndef _RWSTD_NO_MEM_CLASS_TEMPLATES
#if 0
	template <class Y> class autoptr_ref 
	{
	public:
	  autoptr<Y>& p;
	  autoptr_ref(autoptr<Y>& a) : p(a) {}
	};
#endif    

	public:
	typedef X element_type;

	//
	// construct/copy/destroy
	//
	_EXPLICIT autoptr (X* p = 0)  _RWSTD_THROW_SPEC_NULL
	 : the_p(p)
	{ ; }

	autoptr (autoptr<X>& a)  _RWSTD_THROW_SPEC_NULL
	 :  the_p((_RWSTD_CONST_CAST(autoptr<X>&,a)).release()) 
	{ ; }

	autoptr<X>& operator= (autoptr<X>& rhs)  _RWSTD_THROW_SPEC_NULL
	{ 
	  reset(rhs.release());
	  return *this;
	}
//#ifndef _RWSTD_NO_MEMBER_TEMPLATES
#if 0
	template <class Y>
	autoptr (autoptr<Y>& a)  _RWSTD_THROW_SPEC_NULL
	 : the_p((_RWSTD_CONST_CAST(autoptr<Y>&,a)).release()) 
	{ ; }

	template <class Y>
	autoptr<X>& operator= (autoptr<Y>& rhs)  _RWSTD_THROW_SPEC_NULL
	{ 
	  reset(rhs.release());
	  return *this;
	}
#endif

	~autoptr () _RWSTD_THROW_SPEC_NULL { delete the_p; }
	//
	// members
	//
	X& operator*  ()  const _RWSTD_THROW_SPEC_NULL { return *the_p;   }
	X* operator-> ()  const _RWSTD_THROW_SPEC_NULL { return the_p;    }
	X* get        ()  const _RWSTD_THROW_SPEC_NULL { return the_p;    }

	X* release    ()  _RWSTD_THROW_SPEC_NULL
	{ 
	  X* tmp = the_p;
	  the_p = 0; 
	  return tmp; 
	}

	void reset (X* p = 0) _RWSTD_THROW_SPEC_NULL
	{ 
	  if (the_p != p)
	  {
		delete the_p;
		the_p = p;
	  }
	}

//#ifndef _RWSTD_NO_MEM_CLASS_TEMPLATES
#if 0
	autoptr(autoptr_ref<X> r) _RWSTD_THROW_SPEC_NULL
	{
	  reset(r.p.release());
	}
#ifndef _RWSTD_NO_MEMBER_TEMPLATES
	template <class Y> operator autoptr_ref<Y>() _RWSTD_THROW_SPEC_NULL
	{
	  return autoptr_ref<Y>(*this);
	}
	template <class Y> operator autoptr<Y>() _RWSTD_THROW_SPEC_NULL
	{  
	  autoptr<Y> tmp;
	  tmp.reset(release());
	  return tmp;
	}
#endif // _RWSTD_NO_MEMBER_TEMPLATES
#endif // _RWSTD_NO_MEM_CLASS_TEMPLATES

	operator X *() { return the_p; }
	bool operator !() { return !the_p; }

	private:
	X* the_p;
};

#endif	// __DEFS_H

