#ifndef __events_h
#define	__events_h

class TEvent {
protected:
	HANDLE Handle;
public:
	int Counter;	// generic counter
	int Param;		// generic parameter
public:
	TEvent()
	{
		Handle = CreateEvent(NULL, FALSE, FALSE, NULL);
		Counter = 0;
		Param = 0;
	}
	virtual ~TEvent()
	{
		CloseHandle(Handle);
	}
	bool Wait(int msec=INFINITE)
	{
		return WaitForSingleObject(Handle, msec) == WAIT_OBJECT_0;
	}
	void Wake()
	{
		SetEvent(Handle);
	}
};

#endif	// __events_h

