//---------------------------------------------------------------------------

#ifndef prgstrlibH
#define prgstrlibH
//---------------------------------------------------------------------------

class tnstr_que {
protected:
	tnstr **data;
	int num;
	int maxnum;
	int in_index;
	int out_index;
public:
	tnstr_que(int _maxnum);
	~tnstr_que();
	void clear();
	bool push(tnstr *s);
	bool push(const tchar *s);
	tnstr *pop();
	int size() const
		{ return num; }
};

void EscapeURIString( const tchar *str1, tnstr &str2 );

void LowerToUpper( tchar *str );

tchar *itocs( int val, tchar *text );
tnstr itocs(int val);
tchar *itocs64(__int64 val, tchar *text);
tnstr itocs64(__int64 val);

#endif

