//---------------------------------------------------------------------------

#ifndef prgprofileH
#define prgprofileH
//---------------------------------------------------------------------------

#include "regprof.h"

class PrgProfile : public TRegProfile {
typedef TRegProfile super;
public:
	PrgProfile()
		:super(NULL)
	{
	}
	void SetIniMode(const tchar *iniName)
	{
		super::SetIniFile(iniName);
	}

	// ReadString //
	tnstr ReadString( const tchar *section, const tchar *key, const tchar *defval)
		{ return super::ReadString(section, key, defval); }
	tnstr ReadString(const tchar *section, int key, const tchar *defval)
		{ return ReadString(section, GetString(key), defval); }
	tnstr ReadString(const tchar *key, const tchar *defval=NULL)
		{ return Section->ReadString(key, defval); }

	void WriteString(const tchar *section, const tchar *key, const tchar *str)
		{ super::WriteString(section, key, str); }
	void WriteString(const tchar *key, const tchar *str)
		{ Section->WriteString(key, str); }
};

void InitProfile();
void WriteHistory( const tchar *section, tnstr_vec &ha);
void ReadHistory( const tchar *section, tnstr_vec &ha);

extern PrgProfile prof;

#endif

