//---------------------------------------------------------------------------

#ifndef SquViewFrmH
#define SquViewFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "TntForms.hpp"
#include "TntExtCtrls.hpp"
#include "TntStdCtrls.hpp"
#include <ExtCtrls.hpp>
#include "TntMenus.hpp"
#include <Menus.hpp>
//---------------------------------------------------------------------------

class TSquIF;
class TSquUIMain;

class TSquViewFrame : public TTntFrame
{
__published:	// IDE Ǘ̃R|[lg
	TTntPanel *TntPanel1;
	TTntSplitter *splResult;
	TTntListBox *lvResult;
	TTntMemo *edView;
	TTntPopupMenu *pmResult;
	TTntMenuItem *cmOpenEditor;
	void __fastcall lvResultDrawItem(TWinControl *Control, int Index,
		  TRect &Rect, TOwnerDrawState State);
	void __fastcall lvResultDblClick(TObject *Sender);
	void __fastcall cmOpenEditorClick(TObject *Sender);
	void __fastcall lvResultClick(TObject *Sender);
private:	// [U[錾
	class TSearchView *SrchView;
	class TSquIF *SquIF;
public:		// [U[錾
	__fastcall TSquViewFrame(TComponent* Owner, TSquUIMain *main);
	void SetInterface(TSquIF *squ)
		{ SquIF = squ; }
	TSquIF *squi()
		{ return SquIF; }

	void Initialize();
	void Cleanup();

	class TSearchProcI *GetSrchProc()
		{ return SrchProc; }
	bool IsSearching();

	// Result List //
	void SelChanged();
	inline void _SelChanged()	// for VCL bug?
		{ SelChanged(); }
	void ResultSelDown();
	void ResultSelUp();
	void NextSelFile();
	void PrevSelFile();
	void CopyResult();

	void KeyEnter();
	void OpenEditor();
	void OpenTool();

	bool StartSearch(const tchar *pat, const tchar *dir, const tchar *mask, int option);
	void GetSearchParams(struct TSearchParams &params);

	void UpdateMsg();
	//const tchar *GetMsg(int *pasttime);
	
	bool IdleProc();
	inline bool LastIdleDone() const
		{ return FLastIdleDone; }
private:
	class TSearchProcI *SrchProc;
	tnstr SrchPat;
	tnstr SrchDir;
	tnstr SrchMask;
	int SrchOption;
	bool FLastIdleDone;
};
//---------------------------------------------------------------------------
extern PACKAGE TSquViewFrame *SquViewFrame;
//---------------------------------------------------------------------------
#endif

